*:*****************************************************************************
*:
*: Procedure file: E:\PRBFUNC\5.2\PRB_FLAT.PRG
*:
*:         System: Major Function Library
*:         Author: Phil Barnett
*:      Copyright (c) 1987-1994, Phil Barnett
*:  Last modified: 07/19/94     21:09
*:
*:  Procs & Fncts: FLAT_OUT()
*:               : FLAT_IN()
*:               : SHOW_COUNT
*:               : NEXT_VAR
*:               : NEXT_LINE
*:
*:         Set by: SNAP.PRG                          
*:
*:      Documented 07/19/94 at 21:13                SNAP!  version 5.02
*:*****************************************************************************
static TOKEN

*!*****************************************************************************
*!
*!       Function: FLAT_OUT()
*!
*!          Calls: POP_MSG()          (function  in PRB_POP.PRG)
*!               : NEXT_VAR           (procedure in PRB_FLAT.PRG)
*!               : NEXT_LINE          (procedure in PRB_FLAT.PRG)
*!               : NUMAT()            (function  in ?)
*!               : STR2ARRAY()        (function  in PRB_S2A.PRG)
*!               : DBCLEARINDEX()     (function  in ?)
*!               : SHOW_COUNT         (procedure in PRB_FLAT.PRG)
*!
*!    Other Files: SCRIPT
*!               : TEXTOUT
*!
*!*****************************************************************************
function FLAT_OUT(SCRIPT)

local MSG[1],CRLF,CRLF_FLAG,PASS_CNTR,Handle,LENGTH,SCRIPT_TXT
local TEXTOUT,DBFIN,MINDEX,delimiter,NUM_FLDS,FLD_FUNC[1],READIT,Key,x
local THIS_LINE,TEMPVAR,A_INDEX,NUM_ELEMS,MFLD_FUNC

Cls()

CRLF := chr(13)+chr(10)
CRLF_FLAG := .t.
PASS_CNTR := 0

if !file(SCRIPT)
  POP_MSG('Flatfile Conversion Script, '+SCRIPT+' does not exist!')
  return .f.
endif
Handle := fopen(SCRIPT,0)    && Read Only
LENGTH := fseek(Handle,0,2)
fseek(Handle,0,0)
SCRIPT_TXT := space(LENGTH)
fread(Handle,@SCRIPT_TXT,LENGTH)
fclose(Handle)
TEXTOUT := NEXT_VAR(@SCRIPT_TXT)
DBFIN := NEXT_VAR(@SCRIPT_TXT)
if !file(DBFIN)
  POP_MSG('.DBF Input file '+DBFIN+' does not exist!')
  return .f.
endif
MINDEX := NEXT_VAR(@SCRIPT_TXT)
delimiter := NEXT_VAR(@SCRIPT_TXT)
delimiter := &DELIMITER

NUM_FLDS := val(NEXT_VAR(@SCRIPT_TXT))

asize(MSG,15)
Afill(MSG,'')
MSG[1] := 'Conversion Script = '+SCRIPT
MSG[3] := 'Input File = '+DBFIN
MSG[5] := 'Indexes = '+iif(empty(MINDEX),'None',MINDEX)
MSG[7] := 'Output File = '+TEXTOUT
MSG[9] := 'Delimiter = '+delimiter
MSG[11] := 'Number of Positions = '+alltrim(str(NUM_FLDS))
MSG[13] := 'Currently Writing line:        '
MSG[15] := 'Press <Esc> to Abort Operation'
POP_MSG(MSG,.f.)

asize(FLD_FUNC,NUM_FLDS)
for READIT := 1 to NUM_FLDS
  Key := INKEY()
  if Key = 27
    return .f.
  endif
  PASS_CNTR = 0
  THIS_LINE := NEXT_LINE(@SCRIPT_TXT,@PASS_CNTR,@CRLF_FLAG)
  FLD_FUNC[readit] := alltrim(THIS_LINE)
next

* Process each field into it's output line.
PASS_CNTR := 0
select 0
use (DBFIN) alias DESTINATION exclusive
if Neterr()
  POP_MSG('You must have exclusive use of '+DBFIN+' to perform this function.')
  return .f.
endif

if !empty(MINDEX)
  A_INDEX := {}
  if at(",",MINDEX) > 0
    a_index := STR2ARRAY( ",", MINDEX )
  else
    A_INDEX := {MINDEX}
  endif
  DBCLEARINDEX()
  NUM_ELEMS := len( a_index )
  for x := 1 to NUM_ELEMS
    dbsetindex( A_INDEX[x] )
  next
endif

go top
if file(TEXTOUT)
  Handle := fopen(TEXTOUT,2)
else
  Handle := fcreate(TEXTOUT,0)
endif
PASS_CNTR := 0
@ 17,48 say str(PASS_CNTR,6)
do while !eof()
  SHOW_COUNT(++PASS_CNTR)
  THIS_LINE := ''
  for x := 1 to NUM_FLDS
    MFLD_FUNC := alltrim(FLD_FUNC[x])
    TEMPVAR := &MFLD_FUNC
    if valtype(TEMPVAR) <> 'C'
      POP_MSG('You have not correctly converted field '+ltrim(str(x,2))+' to Character')
      fclose(Handle)
      quit
    endif
    THIS_LINE += TEMPVAR + delimiter
  next
  fwrite(Handle,THIS_LINE+CRLF)
  skip
enddo
fclose(Handle)
@ 17,48 say str(PASS_CNTR,6)
return .t.

*!*****************************************************************************
*!
*!       Function: FLAT_IN()
*!
*!          Calls: POP_MSG()          (function  in PRB_POP.PRG)
*!               : NEXT_VAR           (procedure in PRB_FLAT.PRG)
*!               : NEXT_LINE          (procedure in PRB_FLAT.PRG)
*!               : NUMAT()            (function  in ?)
*!               : STR2ARRAY()        (function  in PRB_S2A.PRG)
*!               : DBCLEARINDEX()     (function  in ?)
*!               : SHOW_COUNT         (procedure in PRB_FLAT.PRG)
*!
*!    Other Files: SCRIPT
*!               : TEXTIN
*!
*!*****************************************************************************
function FLAT_IN(SCRIPT)

local BUFF_SIZE,CRLF,CRLF_FLAG,DBFOUT,DESTINATION,Handle,INP_BUFF
local LENGTH,MINDEX,NUM_PARTS,NUM_READ,PARS_BUFF,PASS_CNTR
local POSITIONAL,READIT,SCRIPT_TXT,SP_AT,STRING,TEXTIN,THIS_LINE
local MSG[1],delimiter,NUM_FLDS,E_COL[1],S_COL[1],FLD_NAME[1],FLD_FUNC[1]
local Key,x,LINE_PART[1],MFLD_FUNC,NUM_ELEMS,A_INDEX := {}

memvar TOKEN,MFLD_NAME

Cls()

CRLF := chr(13)+chr(10)
CRLF_FLAG := .t.
PASS_CNTR := 0

if !file(SCRIPT)
  POP_MSG('Flatfile Conversion Script, '+SCRIPT+' does not exist!')
  return .f.
endif
Handle := fopen(SCRIPT,0)    && Read Only
LENGTH := fseek(Handle,0,2)
fseek(Handle,0,0)
SCRIPT_TXT := space(LENGTH)
fread(Handle,@SCRIPT_TXT,LENGTH)
fclose(Handle)
TEXTIN := NEXT_VAR(@SCRIPT_TXT)
if !file(TEXTIN)
  POP_MSG('Text Input file '+TEXTIN+' does not exist!')
  return .f.
endif
DBFOUT := NEXT_VAR(@SCRIPT_TXT)
if !file(DBFOUT)
  POP_MSG('.DBF Output file '+DBFOUT+' does not exist!')
  return .f.
endif
MINDEX := NEXT_VAR(@SCRIPT_TXT)
delimiter := NEXT_VAR(@SCRIPT_TXT)
POSITIONAL := upper(delimiter) = 'POSITION'
if !POSITIONAL
  delimiter := &DELIMITER
endif

NUM_FLDS := val(NEXT_VAR(@SCRIPT_TXT))

asize(MSG,15)
Afill(MSG,'')
MSG[1] := 'Conversion Script = '+SCRIPT
MSG[3] := 'Input File = '+TEXTIN
MSG[5] := 'Output File = '+DBFOUT
MSG[7] := 'Indexes = '+iif(empty(MINDEX),'None',MINDEX)
MSG[9] := 'Delimiter = '+delimiter
MSG[11] := 'Number of Positions = '+alltrim(str(NUM_FLDS))
MSG[13] := 'Currently Reading line:        '
MSG[15] := 'Press <Esc> to Abort Operation'
POP_MSG(MSG,.f.)

asize(S_COL,NUM_FLDS)
asize(E_COL,NUM_FLDS)
asize(FLD_NAME,NUM_FLDS)
asize(FLD_FUNC,NUM_FLDS)
for READIT := 1 to NUM_FLDS
  Key := INKEY()
  if Key = 27
    return .f.
  endif
  THIS_LINE := alltrim(NEXT_LINE(@SCRIPT_TXT,@PASS_CNTR,@CRLF_FLAG))
  
  SP_AT := at(' ',THIS_LINE)
  S_COL[readit] := val(left(THIS_LINE,SP_AT-1))
  THIS_LINE := ltrim(substr(THIS_LINE,SP_AT))
  
  if POSITIONAL
    SP_AT := at(' ',THIS_LINE)
    E_COL[readit] := val(left(THIS_LINE,SP_AT-1))
    THIS_LINE := ltrim(substr(THIS_LINE,SP_AT))
  endif
  
  SP_AT := at(' ',THIS_LINE)
  if SP_AT > 0
    FLD_NAME[readit] := left(THIS_LINE,SP_AT-1)
    THIS_LINE := ltrim(substr(THIS_LINE,SP_AT))
    FLD_FUNC[readit] := alltrim(THIS_LINE)
  else
    FLD_NAME[readit] := alltrim(THIS_LINE)
    FLD_FUNC[readit] := ''
  endif
next

* Read in text, and parse it into lines.
* Process each line into it's components.
PASS_CNTR := 0
CRLF_FLAG := .t.
select 0
use (DBFOUT) exclusive
if Neterr()
  POP_MSG('You must have exclusive use of '+DBFOUT+' to perform this function.')
  return .f.
endif

if !empty(MINDEX)
  A_INDEX := {}
  if at(",",MINDEX) > 0
    a_index := STR2ARRAY(",", MINDEX )
  else
    A_INDEX := {MINDEX}
  endif
  DBCLEARINDEX()
  NUM_ELEMS := len( a_index )
  for x := 1 to NUM_ELEMS
    dbsetindex( A_INDEX[x] )
  next
endif

Handle := fopen(TEXTIN,0)    && Read Only
BUFF_SIZE := 1024
fseek(Handle,0,0)
INP_BUFF := space(BUFF_SIZE)
NUM_READ := fread(Handle,@INP_BUFF,BUFF_SIZE)
PARS_BUFF := ''
@ 17,48 say str(PASS_CNTR,6)
do while NUM_READ = BUFF_SIZE
  PARS_BUFF += INP_BUFF
  do while len(PARS_BUFF) > 512
    Key := INKEY()
    if Key = 27
      select &DBFOUT
      use
      return .f.
    endif
    THIS_LINE := NEXT_LINE(@PARS_BUFF,@PASS_CNTR,@CRLF_FLAG)
    if empty(THIS_LINE) .or. !CRLF_FLAG
      loop
    endif
    if !POSITIONAL
      line_part := STR2ARRAY( delimiter, THIS_LINE )
    endif
    append blank
    for x := 1 to NUM_FLDS
      MFLD_NAME := FLD_NAME[x]
      if MFLD_NAME = 'NULL'
        loop
      endif
      if POSITIONAL
        TOKEN := substr(THIS_LINE,S_COL[x],(E_COL[x]-S_COL[x])+1)
      else
        TOKEN := LINE_PART[x]
      endif
      if !empty(FLD_FUNC[x])
        MFLD_FUNC := alltrim(FLD_FUNC[x])
        TOKEN := &MFLD_FUNC
      endif
      if valtype(MFLD_NAME) <> valtype('token')
        POP_MSG('Conversion type mismatch in field '+ltrim(str(x,2)))
        fclose(Handle)
        quit
      endif
      replace &MFLD_NAME with TOKEN
    next
    SHOW_COUNT(PASS_CNTR)
  enddo
  NUM_READ := fread(Handle,@INP_BUFF,BUFF_SIZE)
enddo
fclose(Handle)
PARS_BUFF := PARS_BUFF + left(INP_BUFF,NUM_READ)

do while CRLF_FLAG
  Key := INKEY()
  if Key = 27
    select &DBFOUT
    use
    return .f.
  endif
  THIS_LINE := NEXT_LINE(@PARS_BUFF,@PASS_CNTR,@CRLF_FLAG)
  if empty(THIS_LINE) .or. !CRLF_FLAG
    loop
  endif
  if !POSITIONAL
    line_part := STR2ARRAY( delimiter, THIS_LINE )
  endif
  append blank
  for x := 1 to NUM_FLDS
    MFLD_NAME := FLD_NAME[x]
    if MFLD_NAME = 'NULL'
      loop
    endif
    if POSITIONAL
      TOKEN := substr(THIS_LINE,S_COL[x],(E_COL[x]-S_COL[x])+1)
    else
      TOKEN := LINE_PART[x]
    endif
    if !empty(FLD_FUNC[x])
      MFLD_FUNC := FLD_FUNC[x]
      TOKEN := &MFLD_FUNC
    endif
    if valtype(MFLD_NAME) <> valtype('token')
      POP_MSG('Conversion type mismatch in field '+ltrim(str(x,2)))
      fclose(Handle)
      quit
    endif
    replace &MFLD_NAME with TOKEN
  next
  SHOW_COUNT(PASS_CNTR)
enddo
@ 17,48 say str(PASS_CNTR,6)

close all

return .t.

*!*****************************************************************************
*!
*!      Procedure: SHOW_COUNT
*!
*!      Called by: FLAT_OUT()         (function  in PRB_FLAT.PRG)
*!               : FLAT_IN()          (function  in PRB_FLAT.PRG)
*!
*!*****************************************************************************
static function SHOW_COUNT(PARM1)

if PARM1%10 = 0
  @ 17,48 say str(PARM1,6)
endif

return NIL

*!*****************************************************************************
*!
*!      Procedure: NEXT_VAR
*!
*!      Called by: FLAT_OUT()         (function  in PRB_FLAT.PRG)
*!               : FLAT_IN()          (function  in PRB_FLAT.PRG)
*!
*!*****************************************************************************
static function NEXT_VAR(ASTRING)

local EOLAT,EQAT,AVAR,CRLF

CRLF = chr(13)+chr(10)

EOLAT := at(CRLF,ASTRING)

if EOLAT = 0
  AVAR := ASTRING
else
  if EOLAT = 1
    AVAR := ''
  else
    AVAR := left(ASTRING,EOLAT-1)
  endif
endif

EQAT := at('=',AVAR)
AVAR := alltrim(substr(AVAR,EQAT+1))

ASTRING := substr(ASTRING,EOLAT+2)

return AVAR

*!*****************************************************************************
*!
*!      Procedure: NEXT_LINE
*!
*!      Called by: FLAT_OUT()         (function  in PRB_FLAT.PRG)
*!               : FLAT_IN()          (function  in PRB_FLAT.PRG)
*!
*!*****************************************************************************
static function NEXT_LINE( ASTRING,PASS_CNTR,CRLF_FLAG )

local EOLAT,AVAR,CRLF

CRLF = chr(13)+chr(10)

EOLAT := at(CRLF,ASTRING)

CRLF_FLAG := (EOLAT>0)

if CRLF_FLAG
  if EOLAT = 1
    AVAR := ''
  else
    AVAR := trim(left(ASTRING,EOLAT-1))
  endif
  ASTRING := substr(ASTRING,EOLAT+2)
else
  AVAR := trim(ASTRING)
  ASTRING := ''
endif

PASS_CNTR ++

return AVAR

*: EOF: PRB_FLAT.PRG
